[4/4] perf test: Test perf lock contention CSV output

Message ID 20230628200141.2739587-5-namhyung@kernel.org
State New
Headers
Series perf lock contention: Add CSV style output support (v2) |

Commit Message

Namhyung Kim June 28, 2023, 8:01 p.m. UTC
  To verify CSV output, just check the number of separators (",") using
the tr and wc commands like this.

  grep -v "^#" ${result} | tr -d -c | wc -c

Now it expects 6 columns (and 5 separators) in the output, but it may
be changed later so count the field in the header first and compare it
to the actual output lines.

  $ cat ${result}
  # output: contended, total wait, max wait, avg wait, type, caller
  1, 28787, 28787, 28787, spinlock, raw_spin_rq_lock_nested+0x1b

The test looks like below now:

  $ sudo ./perf test -v contention
   86: kernel lock contention analysis test                            :
  --- start ---
  test child forked, pid 2705822
  Testing perf lock record and perf lock contention
  Testing perf lock contention --use-bpf
  Testing perf lock record and perf lock contention at the same time
  Testing perf lock contention --threads
  Testing perf lock contention --lock-addr
  Testing perf lock contention --type-filter (w/ spinlock)
  Testing perf lock contention --lock-filter (w/ tasklist_lock)
  Testing perf lock contention --callstack-filter (w/ unix_stream)
  Testing perf lock contention --callstack-filter with task aggregation
  Testing perf lock contention CSV output
  test child finished with 0
  ---- end ----
  kernel lock contention analysis test: Ok

Signed-off-by: Namhyung Kim <namhyung@kernel.org>
---
 tools/perf/tests/shell/lock_contention.sh | 36 +++++++++++++++++++++++
 1 file changed, 36 insertions(+)
  

Comments

Ian Rogers June 30, 2023, 4:14 p.m. UTC | #1
On Wed, Jun 28, 2023 at 1:01 PM Namhyung Kim <namhyung@kernel.org> wrote:
>
> To verify CSV output, just check the number of separators (",") using
> the tr and wc commands like this.
>
>   grep -v "^#" ${result} | tr -d -c | wc -c
>
> Now it expects 6 columns (and 5 separators) in the output, but it may
> be changed later so count the field in the header first and compare it
> to the actual output lines.
>
>   $ cat ${result}
>   # output: contended, total wait, max wait, avg wait, type, caller
>   1, 28787, 28787, 28787, spinlock, raw_spin_rq_lock_nested+0x1b
>
> The test looks like below now:
>
>   $ sudo ./perf test -v contention
>    86: kernel lock contention analysis test                            :
>   --- start ---
>   test child forked, pid 2705822
>   Testing perf lock record and perf lock contention
>   Testing perf lock contention --use-bpf
>   Testing perf lock record and perf lock contention at the same time
>   Testing perf lock contention --threads
>   Testing perf lock contention --lock-addr
>   Testing perf lock contention --type-filter (w/ spinlock)
>   Testing perf lock contention --lock-filter (w/ tasklist_lock)
>   Testing perf lock contention --callstack-filter (w/ unix_stream)
>   Testing perf lock contention --callstack-filter with task aggregation
>   Testing perf lock contention CSV output
>   test child finished with 0
>   ---- end ----
>   kernel lock contention analysis test: Ok
>
> Signed-off-by: Namhyung Kim <namhyung@kernel.org>

Acked-by: Ian Rogers <irogers@google.com>

Thanks,
Ian

> ---
>  tools/perf/tests/shell/lock_contention.sh | 36 +++++++++++++++++++++++
>  1 file changed, 36 insertions(+)
>
> diff --git a/tools/perf/tests/shell/lock_contention.sh b/tools/perf/tests/shell/lock_contention.sh
> index f2cc187b6186..4a194420416e 100755
> --- a/tools/perf/tests/shell/lock_contention.sh
> +++ b/tools/perf/tests/shell/lock_contention.sh
> @@ -233,6 +233,41 @@ test_aggr_task_stack_filter()
>         fi
>  }
>
> +test_csv_output()
> +{
> +       echo "Testing perf lock contention CSV output"
> +       perf lock contention -i ${perfdata} -E 1 -x , --output ${result}
> +       # count the number of commas in the header
> +       # it should have 5: contended, total-wait, max-wait, avg-wait, type, caller
> +       header=$(grep "# output:" ${result} | tr -d -c , | wc -c)
> +       if [ "${header}" != "5" ]; then
> +               echo "[Fail] Recorded result does not have enough output columns: ${header} != 5"
> +               err=1
> +               exit
> +       fi
> +       # count the number of commas in the output
> +       output=$(grep -v "^#" ${result} | tr -d -c , | wc -c)
> +       if [ "${header}" != "${output}" ]; then
> +               echo "[Fail] Recorded result does not match the number of commas: ${header} != ${output}"
> +               err=1
> +               exit
> +       fi
> +
> +       if ! perf lock con -b true > /dev/null 2>&1 ; then
> +               echo "[Skip] No BPF support"
> +               return
> +       fi
> +
> +       # the perf lock contention output goes to the stderr
> +       perf lock con -a -b -E 1 -x , --output ${result} -- perf bench sched messaging > /dev/null 2>&1
> +       output=$(grep -v "^#" ${result} | tr -d -c , | wc -c)
> +       if [ "${header}" != "${output}" ]; then
> +               echo "[Fail] BPF result does not match the number of commas: ${header} != ${output}"
> +               err=1
> +               exit
> +       fi
> +}
> +
>  check
>
>  test_record
> @@ -244,5 +279,6 @@ test_type_filter
>  test_lock_filter
>  test_stack_filter
>  test_aggr_task_stack_filter
> +test_csv_output
>
>  exit ${err}
> --
> 2.41.0.255.g8b1d071c50-goog
>
  

Patch

diff --git a/tools/perf/tests/shell/lock_contention.sh b/tools/perf/tests/shell/lock_contention.sh
index f2cc187b6186..4a194420416e 100755
--- a/tools/perf/tests/shell/lock_contention.sh
+++ b/tools/perf/tests/shell/lock_contention.sh
@@ -233,6 +233,41 @@  test_aggr_task_stack_filter()
 	fi
 }
 
+test_csv_output()
+{
+	echo "Testing perf lock contention CSV output"
+	perf lock contention -i ${perfdata} -E 1 -x , --output ${result}
+	# count the number of commas in the header
+	# it should have 5: contended, total-wait, max-wait, avg-wait, type, caller
+	header=$(grep "# output:" ${result} | tr -d -c , | wc -c)
+	if [ "${header}" != "5" ]; then
+		echo "[Fail] Recorded result does not have enough output columns: ${header} != 5"
+		err=1
+		exit
+	fi
+	# count the number of commas in the output
+	output=$(grep -v "^#" ${result} | tr -d -c , | wc -c)
+	if [ "${header}" != "${output}" ]; then
+		echo "[Fail] Recorded result does not match the number of commas: ${header} != ${output}"
+		err=1
+		exit
+	fi
+
+	if ! perf lock con -b true > /dev/null 2>&1 ; then
+		echo "[Skip] No BPF support"
+		return
+	fi
+
+	# the perf lock contention output goes to the stderr
+	perf lock con -a -b -E 1 -x , --output ${result} -- perf bench sched messaging > /dev/null 2>&1
+	output=$(grep -v "^#" ${result} | tr -d -c , | wc -c)
+	if [ "${header}" != "${output}" ]; then
+		echo "[Fail] BPF result does not match the number of commas: ${header} != ${output}"
+		err=1
+		exit
+	fi
+}
+
 check
 
 test_record
@@ -244,5 +279,6 @@  test_type_filter
 test_lock_filter
 test_stack_filter
 test_aggr_task_stack_filter
+test_csv_output
 
 exit ${err}